<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../">
<head>
  <meta charset="utf-8" /><meta name="viewport" content="width=device-width, initial-scale=1" />

  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Working with Visual Studio Code &mdash; openPASS Documentation</title>
      <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=b86133f3" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/theme.css?v=19f00094" />
      <link rel="stylesheet" type="text/css" href="../../_static/css/custom.css?v=4ad39fc2" />
      <link rel="stylesheet" type="text/css" href="../../_static/tabs.css?v=a5c4661c" />

  
    <link rel="shortcut icon" href="../../_static/openPASS.ico"/>
  <!--[if lt IE 9]>
    <script src="../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script src="../../_static/jquery.js?v=5d32c60e"></script>
        <script src="../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
        <script src="../../_static/documentation_options.js?v=6efca38a"></script>
        <script src="../../_static/doctools.js?v=888ff710"></script>
        <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
        <script src="../../_static/tabs.js?v=3030b3cb"></script>
    <script src="../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Documentation Concept" href="../20_documentation.html" />
    <link rel="prev" title="IDE Support" href="../10_ide_support.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../index.html" class="icon icon-home">
            openPASS
              <img src="../../_static/openPASS.png" class="logo" alt="Logo"/>
          </a>
              <div class="version">
                1.2.0
              </div>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Installation Guide</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/10_getting_started.html">Getting Started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/15_system_requirements.html">System Requirements</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/20_install_prerequisites.html">Installing Prerequisites</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/30_install_openpass.html">Installing openPASS</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/50_further_guidance.html">Further Guidance</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../installation_guide/60_conan.html">Building with Conan</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">User Guides</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/10_overview.html">Overview</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/20_tutorials.html">Tutorials</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/30_configs_in_depth.html">Configs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/40_outputs_in_depth.html">Outputs in Depth</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../user_guide/50_scenario_simulation.html">Simulator</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Advanced topics</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/20_simulator_advanced.html">Simulator</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../advanced_topics/30_testing.html">EndToEnd Test Framework</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Developer Information</span></p>
<ul class="current">
<li class="toctree-l1 current"><a class="reference internal" href="../10_ide_support.html">IDE Support</a><ul class="current">
<li class="toctree-l2 current"><a class="current reference internal" href="#">Working with Visual Studio Code</a><ul>
<li class="toctree-l3"><a class="reference internal" href="#assumptions">Assumptions</a></li>
<li class="toctree-l3"><a class="reference internal" href="#installation">Installation</a></li>
<li class="toctree-l3"><a class="reference internal" href="#set-up-development-containers-in-visual-studio-code">Set Up Development Containers in Visual Studio Code</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#introduction">Introduction</a></li>
<li class="toctree-l4"><a class="reference internal" href="#prerequisites">Prerequisites</a></li>
<li class="toctree-l4"><a class="reference internal" href="#devcontainers">DevContainers</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#configuration">Configuration</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#win-only-msys2-path"> MSYS2 Path</a></li>
<li class="toctree-l4"><a class="reference internal" href="#build-kit">Build Kit</a></li>
<li class="toctree-l4"><a class="reference internal" href="#user-settings">User Settings</a></li>
<li class="toctree-l4"><a class="reference internal" href="#c-and-intellisense">C++ and IntelliSense</a></li>
<li class="toctree-l4"><a class="reference internal" href="#configure-the-build">Configure the Build</a></li>
<li class="toctree-l4"><a class="reference internal" href="#debug-targets">Debug Targets</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="#troubleshooting">Troubleshooting</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../20_documentation.html">Documentation Concept</a></li>
<li class="toctree-l1"><a class="reference internal" href="../30_coding_conventions.html">Coding Guidelines</a></li>
</ul>
<p class="caption" role="heading"><span class="caption-text">Other Information</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/10_external_dependencies.html">External Dependencies</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/20_glossary.html">Glossary</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/30_gui_plugins.html">GUI Plugins</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../other_information/40_license.html">License</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">openPASS</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../10_ide_support.html">IDE Support</a></li>
      <li class="breadcrumb-item active">Working with Visual Studio Code</li>
      <li class="wy-breadcrumbs-aside">
            <a href="../../_sources/developer_information/ide_support/30_vscode.rst.txt" rel="nofollow"> View page source</a>
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <section id="working-with-visual-studio-code">
<span id="vscode"></span><h1>Working with Visual Studio Code<a class="headerlink" href="#working-with-visual-studio-code" title="Link to this heading"></a></h1>
<p>This section describes the basic setup for Visual Studio Code.</p>
<figure class="align-center" id="id1">
<img alt="../../_images/vscode_quick_intro.png" src="../../_images/vscode_quick_intro.png" />
<figcaption>
<p><span class="caption-text">Correctly configured Visual Studio Code showing – among other things – <strong>left</strong>, debugging, testmate, and cmake pane selectors, and at the <strong>bottom</strong>, build type, kit, current target, and CTest runner.</span><a class="headerlink" href="#id1" title="Link to this image"></a></p>
</figcaption>
</figure>
<section id="assumptions">
<h2>Assumptions<a class="headerlink" href="#assumptions" title="Link to this heading"></a></h2>
<ul class="simple">
<li><p>For brevity, non-standard libraries are expected to be in the folder <code class="docutils literal notranslate"><span class="pre">./deps/thirdParty</span></code>.</p></li>
<li><p><img alt="win_only" src="../../_images/win_only.png" /> <strong>MSYS2/MinGW 64 Bit</strong> is used.</p></li>
</ul>
</section>
<section id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Link to this heading"></a></h2>
<ol class="arabic simple">
<li><p>Install Visual Studio Code (<a class="reference external" href="https://code.visualstudio.com">https://code.visualstudio.com</a>)</p></li>
<li><p>Install Extensions</p></li>
</ol>
<table class="docutils align-default">
<thead>
<tr class="row-odd"><th class="head"><p>Name</p></th>
<th class="head"><p>Purpose</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><a class="reference external" href="https://marketplace.visualstudio.com/items?itemName=ms-vscode.cpptools">C/C++</a></p></td>
<td><p>Support for C/C++, including IntelliSense and debugging</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference external" href="https://vector-of-bool.github.io/docs/vscode-cmake-tools">CMake Tools</a></p></td>
<td><p>Extended CMake support</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference external" href="https://marketplace.visualstudio.com/items?itemName=matepek.vscode-catch2-test-adapter">C++ Testmate</a></p></td>
<td><p>Run and debug GoogleTest</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference external" href="https://marketplace.visualstudio.com/items?itemName=fougas.msys2">MSYS2/Cygwin/MinGW/Clang support</a></p></td>
<td><p><img alt="win_only" src="../../_images/win_only.png" /> MSYS2/MinGW configuration adapter</p></td>
</tr>
<tr class="row-even"><td><p><a class="reference external" href="https://code.visualstudio.com/docs/devcontainers/containers">Remote Development</a></p></td>
<td><p>Development using DevContainers</p></td>
</tr>
<tr class="row-odd"><td><p><a class="reference external" href="https://code.visualstudio.com/docs/containers/overview">Docker</a></p></td>
<td><p>Additional information for DevContainer prerequisites</p></td>
</tr>
</tbody>
</table>
</section>
<section id="set-up-development-containers-in-visual-studio-code">
<h2>Set Up Development Containers in Visual Studio Code<a class="headerlink" href="#set-up-development-containers-in-visual-studio-code" title="Link to this heading"></a></h2>
<section id="introduction">
<h3>Introduction<a class="headerlink" href="#introduction" title="Link to this heading"></a></h3>
<p>This section provides step-by-step instructions on setting up development containers in Visual Studio Code (VSCode). Development containers allow you to define and manage your development environment using Docker containers, ensuring consistent and reproducible setups across different machines.</p>
</section>
<section id="prerequisites">
<h3>Prerequisites<a class="headerlink" href="#prerequisites" title="Link to this heading"></a></h3>
<p>Before you begin, make sure <code class="docutils literal notranslate"><span class="pre">docker</span></code> is installed in your system. If <code class="docutils literal notranslate"><span class="pre">docker</span></code> is not installed, follow the below steps.</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-0-0-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-0-0-0" name="0-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-0-0-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-0-0-1" name="0-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-0-0-0" class="sphinx-tabs-panel" id="panel-0-0-0" name="0-0" role="tabpanel" tabindex="0"><ol class="arabic">
<li><p>Open PowerShell in Administrator Mode by right-clicking and selecting “Run as administrator.”.</p></li>
<li><p>To install wsl, run the following command and then restart the machine:</p>
<div class="highlight-powershell notranslate"><div class="highlight"><pre><span></span><span class="n">wsl</span> <span class="p">-</span><span class="n">-install</span>
</pre></div>
</div>
<p>The above command only works if WSL is not installed at all.
If you run <code class="docutils literal notranslate"><span class="pre">wsl</span> <span class="pre">--install</span></code> and see the WSL help text, try running <code class="docutils literal notranslate"><span class="pre">wsl</span> <span class="pre">--list</span> <span class="pre">--online</span></code> to see a list of available distros and run <code class="docutils literal notranslate"><span class="pre">wsl</span> <span class="pre">--install</span> <span class="pre">-d</span> <span class="pre">&lt;Linux</span> <span class="pre">DistroName&gt;</span></code> to install a distro. The recommended distro is <code class="docutils literal notranslate"><span class="pre">Ubuntu</span></code> and the following steps assumes the distro as <code class="docutils literal notranslate"><span class="pre">Ubuntu</span></code></p>
</li>
<li><p>Once the distro is installed, check the version of the installed distro</p>
<div class="highlight-powershell notranslate"><div class="highlight"><pre><span></span><span class="n">wsl</span> <span class="n">-l</span> <span class="n">-v</span>
</pre></div>
</div>
<p>If the version is 1, then change it to 2 using the command <code class="docutils literal notranslate"><span class="pre">wsl</span> <span class="pre">--set-version</span> <span class="pre">&lt;distro&gt;</span> <span class="pre">2</span></code></p>
</li>
<li><p>After successful installation, open Ubuntu by searching <code class="docutils literal notranslate"><span class="pre">Ubuntu</span></code> in windows search bar</p></li>
<li><p>Install the dependencies to run docker on the distro using the following command</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>sudo<span class="w"> </span>apt<span class="w"> </span>install<span class="w"> </span>--no-install-recommends<span class="w"> </span>apt-transport-https<span class="w"> </span>ca-certificates<span class="w"> </span>curl
</pre></div>
</div>
</li>
<li><p>On Debian or Ubuntu, first temporarily set some OS-specific variables:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>.<span class="w"> </span>/etc/os-release
</pre></div>
</div>
<p>Then, make sure <code class="docutils literal notranslate"><span class="pre">apt</span></code> trust the docker repo</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>curl<span class="w"> </span>-fsSL<span class="w"> </span>https://download.docker.com/linux/<span class="si">${</span><span class="nv">ID</span><span class="si">}</span>/gpg<span class="w"> </span><span class="p">|</span><span class="w"> </span>sudo<span class="w"> </span>tee<span class="w"> </span>/etc/apt/trusted.gpg.d/docker.asc
</pre></div>
</div>
<p>ID will be either <code class="docutils literal notranslate"><span class="pre">ubuntu</span></code> or <code class="docutils literal notranslate"><span class="pre">debian</span></code>, as appropriate, depending on what is in <code class="docutils literal notranslate"><span class="pre">/etc/os-release</span></code>.</p>
</li>
<li><p>Add docker repo information to the <code class="docutils literal notranslate"><span class="pre">apt</span></code> to install docker.</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span><span class="nb">echo</span><span class="w"> </span><span class="s2">&quot;deb [arch=amd64] https://download.docker.com/linux/</span><span class="si">${</span><span class="nv">ID</span><span class="si">}</span><span class="s2"> </span><span class="si">${</span><span class="nv">VERSION_CODENAME</span><span class="si">}</span><span class="s2"> stable&quot;</span><span class="w"> </span><span class="p">|</span><span class="w"> </span>sudo<span class="w"> </span>tee<span class="w"> </span>/etc/apt/sources.list.d/docker.list
sudo<span class="w"> </span>apt<span class="w"> </span>update
</pre></div>
</div>
</li>
<li><p>Install Docker and add user to the <code class="docutils literal notranslate"><span class="pre">docker</span></code> group</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>sudo<span class="w"> </span>apt<span class="w"> </span>install<span class="w"> </span>docker-ce<span class="w"> </span>docker-ce-cli<span class="w"> </span>containerd.io
sudo<span class="w"> </span>usermod<span class="w"> </span>-aG<span class="w"> </span>docker<span class="w"> </span><span class="nv">$USER</span>
</pre></div>
</div>
<p>Replace <code class="docutils literal notranslate"><span class="pre">$USER</span></code> with your user name on distro. Then close the WSL window, and launch WSL again. You should see <code class="docutils literal notranslate"><span class="pre">docker</span></code> when you run the command <code class="docutils literal notranslate"><span class="pre">groups</span></code> on command prompt to list group memberships.</p>
</li>
<li><p>Launch <code class="docutils literal notranslate"><span class="pre">dockerd</span></code> using the following command</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>sudo<span class="w"> </span>dockerd
</pre></div>
</div>
<p>There should be several lines of info, warnings related to cgroup blkio, and the like, with something like API listen on /var/run/docker.sock at the end. If so, you have success.
If there is any network controller issue, execute the following compile_commands</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span><span class="nb">echo</span><span class="w"> </span>-e<span class="w"> </span><span class="s2">&quot;[network]\ngenerateResolvConf = false&quot;</span><span class="w"> </span><span class="p">|</span><span class="w"> </span>sudo<span class="w"> </span>tee<span class="w"> </span>-a<span class="w"> </span>/etc/wsl.conf
sudo<span class="w"> </span>unlink<span class="w"> </span>/etc/resolv.conf
<span class="nb">echo</span><span class="w"> </span>nameserver<span class="w"> </span><span class="m">1</span>.1.1.1<span class="w"> </span><span class="p">|</span><span class="w"> </span>sudo<span class="w"> </span>tee<span class="w"> </span>/etc/resolv.conf
</pre></div>
</div>
<p>Also switch to legacy iptables using the following command</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>update-alternatives<span class="w"> </span>--config<span class="w"> </span>iptables
</pre></div>
</div>
<p>And select iptables-legacy
Rerun the command <code class="docutils literal notranslate"><span class="pre">sudo</span> <span class="pre">dockerd</span></code> and check if it is succeeded.</p>
</li>
<li><p>To check if <code class="docutils literal notranslate"><span class="pre">docker</span></code> is running from Windows, in PowerShell execute the following command.</p></li>
</ol>
<blockquote>
<div><div class="highlight-powershell notranslate"><div class="highlight"><pre><span></span><span class="n">wsl</span> <span class="n">-d</span> <span class="n">Ubuntu</span> <span class="n">docker</span> <span class="n">-H</span> <span class="n">unix</span><span class="p">:///</span><span class="n">var</span><span class="p">/</span><span class="n">run</span><span class="p">/</span><span class="n">docker</span><span class="p">.</span><span class="n">sock</span> <span class="p">-</span><span class="n">-version</span>
</pre></div>
</div>
</div></blockquote>
</div><div aria-labelledby="tab-0-0-1" class="sphinx-tabs-panel" hidden="true" id="panel-0-0-1" name="0-1" role="tabpanel" tabindex="0"><ol class="arabic">
<li><p>Open a terminal window.</p></li>
<li><p>Execute the following command</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>docker<span class="w"> </span>--version
</pre></div>
</div>
<p>If Docker is installed, you will see the version information displayed in the terminal.</p>
</li>
<li><p>If Docker is not installed, you can install it using the following steps:</p>
<ol class="arabic">
<li><p>Update your package list using the command:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>sudo<span class="w"> </span>apt<span class="w"> </span>update
</pre></div>
</div>
</li>
<li><p>Install Docker using the following command:</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>sudo<span class="w"> </span>apt<span class="w"> </span>install<span class="w"> </span>docker.io
</pre></div>
</div>
</li>
<li><p>You may need to add your user to the “docker” group to use Docker without sudo. Run the following command to add your user to the group (replace <cite>&lt;username&gt;</cite> with your actual username):</p>
<div class="highlight-bash notranslate"><div class="highlight"><pre><span></span>sudo<span class="w"> </span>usermod<span class="w"> </span>-aG<span class="w"> </span>docker<span class="w"> </span>&lt;username&gt;
</pre></div>
</div>
</li>
</ol>
</li>
</ol>
</div></div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>For more detailed instructions and troubleshooting related to Docker, refer to the official Docker documentation: <a class="reference external" href="https://docs.docker.com/get-docker/">https://docs.docker.com/get-docker/</a></p>
</div>
</section>
<section id="devcontainers">
<h3>DevContainers<a class="headerlink" href="#devcontainers" title="Link to this heading"></a></h3>
<p>Open the repository in VSCode as folder, e.g. by calling <code class="docutils literal notranslate"><span class="pre">code</span> <span class="pre">openpass</span></code> after checking out and then define the development container configuration.</p>
<ol class="arabic">
<li><p>Open the repository as folder, e.g. by calling <code class="docutils literal notranslate"><span class="pre">code</span> <span class="pre">openpass</span></code> after checking out.</p></li>
<li><p>Create the folder <code class="docutils literal notranslate"><span class="pre">.devcontainer</span></code> at the root of the project and configure your development container using JSON format. Below is an example configuration:</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-1-1-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-1-1-0" name="1-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-1-1-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-1-1-1" name="1-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-1-1-0" class="sphinx-tabs-panel" id="panel-1-1-0" name="1-0" role="tabpanel" tabindex="0"><div class="literal-block-wrapper docutils container" id="id2">
<div class="code-block-caption"><span class="caption-text">devcontainer.json</span><a class="headerlink" href="#id2" title="Link to this code"></a></div>
<div class="highlight-javascript notranslate"><div class="highlight"><pre><span></span><span class="linenos">1</span><span class="p">{</span>
<span class="linenos">2</span><span class="w">  </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;openPASS DevContainer&quot;</span><span class="p">,</span>
<span class="linenos">3</span><span class="w">  </span><span class="s2">&quot;dockerFile&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;../utils/Dockerfile&quot;</span><span class="p">,</span>
<span class="linenos">4</span><span class="w">  </span><span class="s2">&quot;workspaceFolder&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;/workspaces/openPASS&quot;</span>
<span class="linenos">5</span><span class="p">}</span>
</pre></div>
</div>
</div>
<p><a class="reference download internal" download="" href="../../_downloads/a65389c511a382161f2a161fdf5ea53f/devcontainer.json"><code class="xref download docutils literal notranslate"><span class="pre">Download</span></code></a></p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>To use docker daemons running on WSL, open <code class="docutils literal notranslate"><span class="pre">settings</span></code> in VSCode and search for <code class="docutils literal notranslate"><span class="pre">Execute</span> <span class="pre">In</span> <span class="pre">WSL</span></code> and select the option to execute in WSL. Also, under <code class="docutils literal notranslate"><span class="pre">Execute</span> <span class="pre">in</span> <span class="pre">WSLDistro</span></code> enter your distro name, for example: <code class="docutils literal notranslate"><span class="pre">Ubuntu</span></code></p>
</div>
</div><div aria-labelledby="tab-1-1-1" class="sphinx-tabs-panel" hidden="true" id="panel-1-1-1" name="1-1" role="tabpanel" tabindex="0"><div class="literal-block-wrapper docutils container" id="id3">
<div class="code-block-caption"><span class="caption-text">devcontainer.json</span><a class="headerlink" href="#id3" title="Link to this code"></a></div>
<div class="highlight-javascript notranslate"><div class="highlight"><pre><span></span><span class="linenos">1</span><span class="p">{</span>
<span class="linenos">2</span><span class="w">  </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;openPASS DevContainer&quot;</span><span class="p">,</span>
<span class="linenos">3</span><span class="w">  </span><span class="s2">&quot;dockerFile&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;../utils/Dockerfile&quot;</span><span class="p">,</span>
<span class="linenos">4</span><span class="w">  </span><span class="s2">&quot;workspaceFolder&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;/workspaces/openPASS&quot;</span>
<span class="linenos">5</span><span class="p">}</span>
</pre></div>
</div>
</div>
<p><a class="reference download internal" download="" href="../../_downloads/a65389c511a382161f2a161fdf5ea53f/devcontainer.json"><code class="xref download docutils literal notranslate"><span class="pre">Download</span></code></a></p>
</div></div>
</li>
<li><p>Open Your Project in a Development Container:</p>
<ol class="arabic simple">
<li><p>Open the command palette by pressing <cite>Ctrl+Shift+P</cite>.</p></li>
<li><p>Type “Dev Containers: Open Folder in Container” and select your project folder.</p></li>
<li><p>VSCode will build the Docker container based on the configuration and open your project inside it.</p></li>
</ol>
</li>
<li><p>Developing in the Container:</p>
<ol class="arabic simple">
<li><p>You can now edit files, install packages, and run code within the development container.</p></li>
<li><p>Installed extensions and settings in the container will be isolated from your local environment.</p></li>
</ol>
</li>
<li><p>To exit the container, click on the bottom left status bar where it shows the container name and click “Close Remote Connection.”</p></li>
</ol>
</section>
</section>
<section id="configuration">
<h2>Configuration<a class="headerlink" href="#configuration" title="Link to this heading"></a></h2>
<section id="win-only-msys2-path">
<h3><img alt="win_only" src="../../_images/win_only.png" /> MSYS2 Path<a class="headerlink" href="#win-only-msys2-path" title="Link to this heading"></a></h3>
<p>Normally, runtime dependencies (DLLs) are not copied into the executables folder within the build process.
This means, that programs cannot be executed natively from Windows shells or the explorer.
It is therefore highly recommended, to set the environmental variable <code class="docutils literal notranslate"><span class="pre">MSYSTEM=MINGW64</span></code> and <code class="docutils literal notranslate"><span class="pre">CHERE_INVOKING=1</span></code>.
The setting of <code class="docutils literal notranslate"><span class="pre">MSYSTEM</span></code> will cause the environment to be set up correctly for MinGW64.
Windows will then look for DLLs within the msys64 folders, allowing native execution.
<code class="docutils literal notranslate"><span class="pre">CHERE_INVOKING</span></code> makes sure the shell stays in the current working directory.
As investigated recently, the <code class="docutils literal notranslate"><span class="pre">C:\msys64\usr\bin``must</span> <span class="pre">also</span> <span class="pre">be</span> <span class="pre">added</span> <span class="pre">to</span> <span class="pre">the</span> <span class="pre">``PATH</span></code> environment variable in order to resolve dependencies to <code class="docutils literal notranslate"><span class="pre">cygpath.exe</span></code>.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If <code class="docutils literal notranslate"><span class="pre">C:\msys64</span></code> is not already listed in <code class="docutils literal notranslate"><span class="pre">PATH</span></code> variable, then add <code class="docutils literal notranslate"><span class="pre">C:\msys64</span></code> in <code class="docutils literal notranslate"><span class="pre">PATH</span></code> variable before adding <code class="docutils literal notranslate"><span class="pre">C:\msys64\usr\bin</span></code> to the <code class="docutils literal notranslate"><span class="pre">PATH</span></code> variable.
If there are any other Unix like environments installed on Windows operating systems (example: cygwin), there might even be file collisions when calling certain cmake commands.
Therefore, it is suggested to add <code class="docutils literal notranslate"><span class="pre">C:\msys64</span></code> in <code class="docutils literal notranslate"><span class="pre">PATH</span></code> variable before any other Unix like environmental calls.</p>
</div>
<p>Either set environment variable through the <code class="docutils literal notranslate"><span class="pre">Windows</span> <span class="pre">PowerShell</span></code></p>
<div class="highlight-shell notranslate"><div class="highlight"><pre><span></span><span class="c1"># check if set</span>
<span class="nb">echo</span><span class="w"> </span><span class="si">${</span><span class="nv">env</span><span class="p">:</span><span class="nv">path</span><span class="si">}</span>
<span class="nb">echo</span><span class="w"> </span><span class="si">${</span><span class="nv">env</span><span class="p">:</span><span class="nv">MSYSTEM</span><span class="si">}</span>
<span class="nb">echo</span><span class="w"> </span><span class="si">${</span><span class="nv">env</span><span class="p">:</span><span class="nv">CHERE_INVOKING</span><span class="si">}</span>

<span class="c1"># if not</span>
setx<span class="w"> </span>path<span class="w"> </span><span class="s2">&quot;%PATH%;C:\msys64\usr\bin&quot;</span>
setx<span class="w"> </span>MSYSTEM<span class="w"> </span><span class="s2">&quot;MINGW64&quot;</span>
setx<span class="w"> </span>CHERE_INVOKING<span class="w"> </span><span class="s2">&quot;1&quot;</span>
</pre></div>
</div>
<p>or</p>
<ol class="arabic simple">
<li><p>Open the start search</p></li>
<li><p>Type in “env” and choose “Edit the system environment variables”</p></li>
<li><p>Choose “Environment Variables…”</p></li>
<li><p>Set the environment variables:</p>
<ol class="lowerroman simple">
<li><p>MSYSTEM=MINGW64</p></li>
<li><p>CHERE_INVOKING=1</p></li>
<li><p>Add <code class="docutils literal notranslate"><span class="pre">C:\msys64\usr\bin</span></code> to PATH</p></li>
</ol>
</li>
</ol>
<p>Visual Studio Code needs to be reloaded/restarted after the path update.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>An optimal solution would be to set the system environment variables in VSCode under <code class="docutils literal notranslate"><span class="pre">settings.json</span></code>. This is currently not possible. Please contact us if you find a better solution.</p>
</div>
</section>
<section id="build-kit">
<h3>Build Kit<a class="headerlink" href="#build-kit" title="Link to this heading"></a></h3>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-2-2-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-2-2-0" name="2-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-2-2-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-2-2-1" name="2-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-2-2-0" class="sphinx-tabs-panel" id="panel-2-2-0" name="2-0" role="tabpanel" tabindex="0"><p><strong>Add and select MSYS2/MinGW64 Build Kit:</strong></p>
<ol class="arabic">
<li><p>Execute <code class="docutils literal notranslate"><span class="pre">Ctrl+Shift+P</span></code>: <code class="docutils literal notranslate"><span class="pre">CMake:</span> <span class="pre">Edit</span> <span class="pre">User-Local</span> <span class="pre">CMake</span> <span class="pre">Kits</span></code></p></li>
<li><p>Insert/Update:</p>
<div class="literal-block-wrapper docutils container" id="id4">
<div class="code-block-caption"><span class="caption-text">cmake-tools-kits.json</span><a class="headerlink" href="#id4" title="Link to this code"></a></div>
<div class="highlight-javascript notranslate"><div class="highlight"><pre><span></span><span class="linenos"> 1</span><span class="p">[</span>
<span class="linenos"> 2</span><span class="w">    </span><span class="p">{</span>
<span class="linenos"> 3</span><span class="w">        </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;MinGW64&quot;</span><span class="p">,</span>
<span class="linenos"> 4</span><span class="w">        </span><span class="s2">&quot;preferredGenerator&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span>
<span class="linenos"> 5</span><span class="w">            </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;MSYS Makefiles&quot;</span>
<span class="linenos"> 6</span><span class="w">        </span><span class="p">},</span>
<span class="linenos"> 7</span><span class="w">        </span><span class="s2">&quot;environmentVariables&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span><span class="w"> </span><span class="s2">&quot;PATH&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${command:mingw64.path}&quot;</span><span class="w"> </span><span class="p">},</span>
<span class="linenos"> 8</span><span class="w">        </span><span class="s2">&quot;compilers&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span>
<span class="linenos"> 9</span><span class="w">            </span><span class="s2">&quot;C&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${command:mingw64.cc.exe}&quot;</span><span class="p">,</span>
<span class="linenos">10</span><span class="w">            </span><span class="s2">&quot;CXX&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${command:mingw64.cxx.exe}&quot;</span><span class="p">,</span>
<span class="linenos">11</span><span class="w">            </span><span class="s2">&quot;Fortran&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${command:mingw64.fc.exe}&quot;</span>
<span class="linenos">12</span><span class="w">        </span><span class="p">},</span>
<span class="linenos">13</span><span class="w">        </span><span class="s2">&quot;keep&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">14</span><span class="w">    </span><span class="p">}</span>
<span class="linenos">15</span><span class="p">]</span>
</pre></div>
</div>
</div>
<p><a class="reference download internal" download="" href="../../_downloads/0434e3ab992f6eea8e1df4ae553aa93d/cmake-tools-kits.json"><code class="xref download docutils literal notranslate"><span class="pre">Download</span></code></a></p>
</li>
<li><p><code class="docutils literal notranslate"><span class="pre">Ctrl+Shift+P</span></code>: <code class="docutils literal notranslate"><span class="pre">CMake:</span> <span class="pre">Select</span> <span class="pre">a</span> <span class="pre">Kit</span></code> = <code class="docutils literal notranslate"><span class="pre">MinGW64</span></code></p></li>
</ol>
</div><div aria-labelledby="tab-2-2-1" class="sphinx-tabs-panel" hidden="true" id="panel-2-2-1" name="2-1" role="tabpanel" tabindex="0"><p><strong>Select System Build Kit:</strong></p>
<p><code class="docutils literal notranslate"><span class="pre">Ctrl+Shift+P</span></code>: <code class="docutils literal notranslate"><span class="pre">CMake:</span> <span class="pre">Select</span> <span class="pre">a</span> <span class="pre">Kit</span></code> = <code class="docutils literal notranslate"><span class="pre">GCC</span> <span class="pre">10.2.0</span></code></p>
<p>See also <a class="reference internal" href="../../installation_guide/20_install_prerequisites.html#prerequisites"><span class="std std-ref">Installing Prerequisites</span></a>.</p>
</div></div>
</section>
<section id="user-settings">
<span id="vscode-user-settings"></span><h3>User Settings<a class="headerlink" href="#user-settings" title="Link to this heading"></a></h3>
<ol class="arabic">
<li><p>Execute <code class="docutils literal notranslate"><span class="pre">Ctrl+Shift+P</span></code>: <code class="docutils literal notranslate"><span class="pre">Preferences</span> <span class="pre">Open</span> <span class="pre">Workspace</span> <span class="pre">Settings</span> <span class="pre">(JSON)</span></code></p></li>
<li><p>Insert/Update:</p>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-3-3-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-3-3-0" name="3-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-3-3-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-3-3-1" name="3-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-3-3-0" class="sphinx-tabs-panel" id="panel-3-3-0" name="3-0" role="tabpanel" tabindex="0"><div class="literal-block-wrapper docutils container" id="id5">
<div class="code-block-caption"><span class="caption-text">settings.json</span><a class="headerlink" href="#id5" title="Link to this code"></a></div>
<div class="highlight-javascript notranslate"><div class="highlight"><pre><span></span><span class="linenos"> 1</span><span class="p">{</span>
<span class="linenos"> 2</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos"> 3</span><span class="w">    </span><span class="c1">// CMAKE</span>
<span class="linenos"> 4</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos"> 5</span><span class="w">    </span><span class="c1">// Following settings are from the MSYS2 extension documentation</span>
<span class="linenos"> 6</span><span class="w">    </span><span class="s2">&quot;cmake.cmakePath&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;C:\\msys64\\mingw64\\bin\\cmake.exe&quot;</span><span class="p">,</span>
<span class="linenos"> 7</span><span class="w">    </span><span class="s2">&quot;cmake.preferredGenerators&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos"> 8</span><span class="w">        </span><span class="s2">&quot;MSYS Makefiles&quot;</span>
<span class="linenos"> 9</span><span class="w">    </span><span class="p">],</span>
<span class="linenos">10</span><span class="w">    </span><span class="s2">&quot;cmake.configureSettings&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span>
<span class="linenos">11</span><span class="w">        </span><span class="s2">&quot;CMAKE_MAKE_PROGRAM&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;C:\\msys64\\mingw64\\bin\\make.exe&quot;</span><span class="p">,</span>
<span class="linenos">12</span><span class="w">        </span><span class="s2">&quot;CMAKE_PREFIX_PATH&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">13</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/Yase&quot;</span><span class="p">,</span>
<span class="linenos">14</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/FMILibrary&quot;</span><span class="p">,</span>
<span class="linenos">15</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/MantleAPI&quot;</span><span class="p">,</span>
<span class="linenos">16</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/osi&quot;</span><span class="p">,</span>
<span class="linenos">17</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/protobuf&quot;</span><span class="p">,</span>
<span class="linenos">18</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/protobuf-shared&quot;</span><span class="p">,</span>
<span class="linenos">19</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/googletest&quot;</span><span class="p">,</span>
<span class="linenos">20</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/minizip&quot;</span><span class="p">,</span>
<span class="linenos">21</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/openscenario_engine/release&quot;</span><span class="p">,</span>
<span class="linenos">22</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/openscenario_api&quot;</span><span class="p">,</span>
<span class="linenos">23</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/zlib&quot;</span><span class="p">,</span>
<span class="linenos">24</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/open-simulation-interface&quot;</span><span class="p">,</span>
<span class="linenos">25</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/thirdParty/win64/units&quot;</span><span class="p">,</span>
<span class="linenos">26</span><span class="w">            </span><span class="s2">&quot;${workspaceRoot}/deps/scmThirdParty/win64/stochastics&quot;</span><span class="p">,</span>
<span class="linenos">27</span><span class="w">            </span><span class="s2">&quot;C:/msys64/mingw64/bin&quot;</span>
<span class="linenos">28</span><span class="w">        </span><span class="p">],</span>
<span class="linenos">29</span><span class="w">        </span><span class="s2">&quot;CMAKE_INSTALL_PREFIX&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${workspaceRoot}/bin/core&quot;</span><span class="p">,</span>
<span class="linenos">30</span><span class="w">        </span><span class="s2">&quot;CMAKE_BUILD_TYPE&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;Debug&quot;</span><span class="p">,</span>
<span class="linenos">31</span><span class="w">        </span><span class="s2">&quot;USE_CCACHE&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">32</span><span class="w">        </span><span class="s2">&quot;WITH_DEBUG_POSTFIX&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">33</span><span class="w">        </span><span class="s2">&quot;OPENPASS_ADJUST_OUTPUT&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">34</span><span class="w">        </span><span class="s2">&quot;WITH_API_DOC&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">35</span><span class="w">        </span><span class="s2">&quot;WITH_DOC&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">36</span><span class="w">        </span><span class="s2">&quot;INSTALL_EXTRA_RUNTIME_DEPS&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">37</span><span class="w">        </span><span class="s2">&quot;INSTALL_SYSTEM_RUNTIME_DEPS&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">38</span><span class="w">        </span><span class="c1">// For integration with IntelliSense (see c_cpp_properties.json)</span>
<span class="linenos">39</span><span class="w">        </span><span class="s2">&quot;CMAKE_EXPORT_COMPILE_COMMANDS&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">40</span><span class="w">    </span><span class="p">},</span>
<span class="linenos">41</span><span class="w">    </span><span class="c1">// Optional: Adjust to your needs</span>
<span class="linenos">42</span><span class="w">    </span><span class="s2">&quot;cmake.parallelJobs&quot;</span><span class="o">:</span><span class="w"> </span><span class="mf">4</span><span class="p">,</span>
<span class="linenos">43</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos">44</span><span class="w">    </span><span class="c1">// TESTMATE</span>
<span class="linenos">45</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos">46</span><span class="w">    </span><span class="c1">// Optional: Adjust to your needs</span>
<span class="linenos">47</span><span class="w">    </span><span class="s2">&quot;testMate.cpp.test.parallelExecutionLimit&quot;</span><span class="o">:</span><span class="w"> </span><span class="mf">4</span><span class="p">,</span>
<span class="linenos">48</span><span class="w">    </span><span class="s2">&quot;testMate.cpp.test.parallelExecutionOfExecutableLimit&quot;</span><span class="o">:</span><span class="w"> </span><span class="mf">2</span><span class="p">,</span>
<span class="linenos">49</span><span class="w">    </span><span class="c1">// Optional: Set, if you like to debug test discovery and test start issues</span>
<span class="linenos">50</span><span class="w">    </span><span class="s2">&quot;testMate.cpp.log.logfile&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;C:\\temp\\cpp.testmate.log&quot;</span><span class="p">,</span>
<span class="linenos">51</span><span class="w">    </span><span class="c1">// Optional:    As CTest triggers the install step, dependencies between test executables</span>
<span class="linenos">52</span><span class="w">    </span><span class="c1">//              and openpass libraries can be resolved by linking text executables to</span>
<span class="linenos">53</span><span class="w">    </span><span class="c1">//              openpass install directory</span>
<span class="linenos">54</span><span class="w">    </span><span class="c1">// Alternative: Check dependencies of test executables by &#39;ldd &lt;_Tests.exe&gt; and copy</span>
<span class="linenos">55</span><span class="w">    </span><span class="c1">//              libraries right next to test executable within build direcory</span>
<span class="linenos">56</span><span class="w">    </span><span class="s2">&quot;testMate.cpp.test.advancedExecutables&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">57</span><span class="w">        </span><span class="p">{</span>
<span class="linenos">58</span><span class="w">            </span><span class="s2">&quot;pattern&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;build/**/*{tests,Tests,TESTS}*&quot;</span><span class="p">,</span>
<span class="linenos">59</span><span class="w">            </span><span class="s2">&quot;env&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span>
<span class="linenos">60</span><span class="w">                </span><span class="s2">&quot;Path&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;C:\\msys64\\mingw64\\bin;${workspaceFolder}\\bin\\core;${workspaceFolder}\\bin\\core\\lib;${os_env:PATH};${workspaceFolder}\\deps\\thirdParty\\win64\\FMILibrary\\lib;${workspaceFolder}\\deps\\thirdParty\\win64\\osi\\lib\\osi3&quot;</span>
<span class="linenos">61</span><span class="w">            </span><span class="p">}</span>
<span class="linenos">62</span><span class="w">        </span><span class="p">}</span>
<span class="linenos">63</span><span class="w">    </span><span class="p">],</span>
<span class="linenos">64</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos">65</span><span class="w">    </span><span class="c1">// VSCODE</span>
<span class="linenos">66</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos">67</span><span class="w">    </span><span class="c1">// Optional: Integration of MinGW64 Terminal in VS Code</span>
<span class="linenos">68</span><span class="w">    </span><span class="s2">&quot;terminal.integrated.profiles.windows&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span>
<span class="linenos">69</span><span class="w">        </span><span class="s2">&quot;MinGW64&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span>
<span class="linenos">70</span><span class="w">            </span><span class="s2">&quot;overrideName&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">71</span><span class="w">            </span><span class="s2">&quot;path&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">72</span><span class="w">                </span><span class="s2">&quot;C:\\msys64\\usr\\bin\\bash.exe&quot;</span>
<span class="linenos">73</span><span class="w">            </span><span class="p">],</span>
<span class="linenos">74</span><span class="w">            </span><span class="s2">&quot;args&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span><span class="s2">&quot;--login&quot;</span><span class="p">,</span><span class="w"> </span><span class="s2">&quot;-i&quot;</span><span class="p">],</span>
<span class="linenos">75</span><span class="w">            </span><span class="s2">&quot;icon&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;terminal-bash&quot;</span><span class="p">,</span>
<span class="linenos">76</span><span class="w">            </span><span class="s2">&quot;env&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span>
<span class="linenos">77</span><span class="w">                </span><span class="s2">&quot;MSYSTEM&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;MINGW64&quot;</span><span class="p">,</span>
<span class="linenos">78</span><span class="w">                </span><span class="s2">&quot;CHERE_INVOKING&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;1&quot;</span><span class="p">,</span>
<span class="linenos">79</span><span class="w">                </span><span class="s2">&quot;MSYS2_PATH_TYPE&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;inherit&quot;</span>
<span class="linenos">80</span><span class="w">            </span><span class="p">}</span>
<span class="linenos">81</span><span class="w">        </span><span class="p">}</span>
<span class="linenos">82</span><span class="w">    </span><span class="p">},</span>
<span class="linenos">83</span><span class="w">    </span><span class="s2">&quot;terminal.integrated.defaultProfile.windows&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;MinGW64&quot;</span><span class="p">,</span>
<span class="linenos">84</span><span class="w">    </span><span class="c1">// Enforce usage of .clang-format of modified code</span>
<span class="linenos">85</span><span class="w">    </span><span class="s2">&quot;editor.formatOnSave&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">86</span><span class="w">    </span><span class="s2">&quot;editor.formatOnSaveMode&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;modifications&quot;</span><span class="p">,</span>
<span class="linenos">87</span><span class="w">    </span><span class="c1">// EOL and whitespace enforcement</span>
<span class="linenos">88</span><span class="w">    </span><span class="s2">&quot;editor.detectIndentation&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">89</span><span class="w">    </span><span class="s2">&quot;editor.insertSpaces&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">90</span><span class="w">    </span><span class="s2">&quot;editor.renderFinalNewline&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;dimmed&quot;</span><span class="p">,</span>
<span class="linenos">91</span><span class="w">    </span><span class="s2">&quot;files.insertFinalNewline&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">92</span><span class="w">    </span><span class="s2">&quot;files.trimFinalNewlines&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">93</span><span class="w">    </span><span class="s2">&quot;files.trimTrailingWhitespace&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">94</span><span class="p">}</span>
</pre></div>
</div>
</div>
<p><a class="reference download internal" download="" href="../../_downloads/cf3a708e6048855aab4490b408d22f7c/settings.json"><code class="xref download docutils literal notranslate"><span class="pre">Download</span></code></a></p>
</div><div aria-labelledby="tab-3-3-1" class="sphinx-tabs-panel" hidden="true" id="panel-3-3-1" name="3-1" role="tabpanel" tabindex="0"><div class="literal-block-wrapper docutils container" id="id6">
<div class="code-block-caption"><span class="caption-text">settings.json</span><a class="headerlink" href="#id6" title="Link to this code"></a></div>
<div class="highlight-javascript notranslate"><div class="highlight"><pre><span></span><span class="linenos"> 1</span><span class="p">{</span>
<span class="linenos"> 2</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos"> 3</span><span class="w">    </span><span class="c1">// CMAKE</span>
<span class="linenos"> 4</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos"> 5</span><span class="w">    </span><span class="c1">// Optional: Adjust to your needs</span>
<span class="linenos"> 6</span><span class="w">    </span><span class="s2">&quot;cmake.parallelJobs&quot;</span><span class="o">:</span><span class="w"> </span><span class="mf">4</span><span class="p">,</span>
<span class="linenos"> 7</span><span class="w">    </span><span class="c1">// See openPASS documentation for individual WITH_* settings</span>
<span class="linenos"> 8</span><span class="w">    </span><span class="s2">&quot;cmake.configureSettings&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">{</span>
<span class="linenos"> 9</span><span class="w">        </span><span class="c1">// Adjust paths depending on your system</span>
<span class="linenos">10</span><span class="w">        </span><span class="s2">&quot;CMAKE_PREFIX_PATH&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">11</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/Yase&quot;</span><span class="p">,</span>
<span class="linenos">12</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/scmThirdParty/linux64/stochastics&quot;</span><span class="p">,</span>
<span class="linenos">13</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/MantleAPI&quot;</span><span class="p">,</span>
<span class="linenos">14</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/FMILibrary&quot;</span><span class="p">,</span>
<span class="linenos">15</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/protobuf&quot;</span><span class="p">,</span>
<span class="linenos">16</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/protobuf-shared&quot;</span><span class="p">,</span>
<span class="linenos">17</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/googletest&quot;</span><span class="p">,</span>
<span class="linenos">18</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/minizip&quot;</span><span class="p">,</span>
<span class="linenos">19</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/openscenario_api&quot;</span><span class="p">,</span>
<span class="linenos">20</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/openscenario_engine/release&quot;</span><span class="p">,</span>
<span class="linenos">21</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/open-simulation-interface&quot;</span><span class="p">,</span>
<span class="linenos">22</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/zlib&quot;</span><span class="p">,</span>
<span class="linenos">23</span><span class="w">            </span><span class="s2">&quot;${workspaceFolder}/deps/thirdParty/linux64/units&quot;</span>
<span class="linenos">24</span><span class="w">        </span><span class="p">],</span>
<span class="linenos">25</span><span class="w">        </span><span class="s2">&quot;CMAKE_INSTALL_PREFIX&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;/usr/local/openPASS/bin/core&quot;</span><span class="p">,</span>
<span class="linenos">26</span><span class="w">        </span><span class="s2">&quot;CMAKE_BUILD_TYPE&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;Debug&quot;</span><span class="p">,</span>
<span class="linenos">27</span><span class="w">        </span><span class="s2">&quot;USE_CCACHE&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">28</span><span class="w">        </span><span class="s2">&quot;WITH_DEBUG_POSTFIX&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">29</span><span class="w">        </span><span class="s2">&quot;OPENPASS_ADJUST_OUTPUT&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">30</span><span class="w">        </span><span class="s2">&quot;INSTALL_EXTRA_RUNTIME_DEPS&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">31</span><span class="w">        </span><span class="s2">&quot;WITH_API_DOC&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">32</span><span class="w">        </span><span class="s2">&quot;WITH_DOC&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">33</span><span class="w">        </span><span class="s2">&quot;WITH_TESTS&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">34</span><span class="w">        </span><span class="c1">// For integration with IntelliSense (see c_cpp_properties.json)</span>
<span class="linenos">35</span><span class="w">        </span><span class="s2">&quot;CMAKE_EXPORT_COMPILE_COMMANDS&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">36</span><span class="w">    </span><span class="p">},</span>
<span class="linenos">37</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos">38</span><span class="w">    </span><span class="c1">// TESTMATE</span>
<span class="linenos">39</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos">40</span><span class="w">    </span><span class="c1">// Optional: Adjust to your needs</span>
<span class="linenos">41</span><span class="w">    </span><span class="s2">&quot;testMate.cpp.test.parallelExecutionLimit&quot;</span><span class="o">:</span><span class="w"> </span><span class="mf">4</span><span class="p">,</span>
<span class="linenos">42</span><span class="w">    </span><span class="s2">&quot;testMate.cpp.test.parallelExecutionOfExecutableLimit&quot;</span><span class="o">:</span><span class="w"> </span><span class="mf">2</span><span class="p">,</span>
<span class="linenos">43</span><span class="w">    </span><span class="c1">// Optional: Set, if you like to debug test discovery and test start issues</span>
<span class="linenos">44</span><span class="w">    </span><span class="s2">&quot;testMate.cpp.log.logfile&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;/tmp/cpp.testmate.log&quot;</span><span class="p">,</span>
<span class="linenos">45</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos">46</span><span class="w">    </span><span class="c1">// VSCODE</span>
<span class="linenos">47</span><span class="w">    </span><span class="c1">//</span>
<span class="linenos">48</span><span class="w">    </span><span class="c1">// Enforce usage of .clang-format of modified code</span>
<span class="linenos">49</span><span class="w">    </span><span class="s2">&quot;editor.formatOnSave&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">50</span><span class="w">    </span><span class="s2">&quot;editor.formatOnSaveMode&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;modifications&quot;</span><span class="p">,</span>
<span class="linenos">51</span><span class="w">    </span><span class="c1">// EOL and whitespace enforcement</span>
<span class="linenos">52</span><span class="w">    </span><span class="s2">&quot;editor.detectIndentation&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">53</span><span class="w">    </span><span class="s2">&quot;editor.insertSpaces&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">54</span><span class="w">    </span><span class="s2">&quot;editor.renderFinalNewline&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;dimmed&quot;</span><span class="p">,</span>
<span class="linenos">55</span><span class="w">    </span><span class="s2">&quot;editor.renderWhitespace&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;all&quot;</span><span class="p">,</span>
<span class="linenos">56</span><span class="w">    </span><span class="s2">&quot;editor.trimAutoWhitespace&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">57</span><span class="w">    </span><span class="s2">&quot;files.insertFinalNewline&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">58</span><span class="w">    </span><span class="s2">&quot;files.trimFinalNewlines&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span><span class="p">,</span>
<span class="linenos">59</span><span class="w">    </span><span class="s2">&quot;files.trimTrailingWhitespace&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">60</span><span class="p">}</span>
</pre></div>
</div>
</div>
<p><a class="reference download internal" download="" href="../../_downloads/631d97fb2e9fb8f8491268ef3e6ec616/settings.json"><code class="xref download docutils literal notranslate"><span class="pre">Download</span></code></a></p>
</div></div>
</li>
</ol>
</section>
<section id="c-and-intellisense">
<h3>C++ and IntelliSense<a class="headerlink" href="#c-and-intellisense" title="Link to this heading"></a></h3>
<ol class="arabic">
<li><p>Execute <code class="docutils literal notranslate"><span class="pre">Ctrl+Shift+P</span></code>: <code class="docutils literal notranslate"><span class="pre">C/C++:</span> <span class="pre">Edit</span> <span class="pre">Configurations</span> <span class="pre">(JSON)</span></code></p></li>
<li><div class="literal-block-wrapper docutils container" id="id7">
<div class="code-block-caption"><span class="caption-text">c_cpp_properties.json</span><a class="headerlink" href="#id7" title="Link to this code"></a></div>
<div class="highlight-javascript notranslate"><div class="highlight"><pre><span></span><span class="linenos"> 1</span><span class="p">{</span>
<span class="linenos"> 2</span><span class="w">    </span><span class="s2">&quot;configurations&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos"> 3</span><span class="w">        </span><span class="p">{</span>
<span class="linenos"> 4</span><span class="w">            </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;openpass&quot;</span><span class="p">,</span>
<span class="linenos"> 5</span><span class="w">            </span><span class="s2">&quot;cStandard&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;c99&quot;</span><span class="p">,</span>
<span class="linenos"> 6</span><span class="w">            </span><span class="s2">&quot;cppStandard&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;c++17&quot;</span><span class="p">,</span>
<span class="linenos"> 7</span><span class="w">            </span><span class="s2">&quot;configurationProvider&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;ms-vscode.cmake-tools&quot;</span><span class="p">,</span>
<span class="linenos"> 8</span><span class="w">            </span><span class="s2">&quot;compileCommands&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${workspaceFolder}/build/compile_commands.json&quot;</span><span class="p">,</span>
<span class="linenos"> 9</span><span class="w">            </span><span class="s2">&quot;intelliSenseMode&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;linux-gcc-x64&quot;</span>
<span class="linenos">10</span><span class="w">        </span><span class="p">}</span>
<span class="linenos">11</span><span class="w">    </span><span class="p">],</span>
<span class="linenos">12</span><span class="w">    </span><span class="s2">&quot;version&quot;</span><span class="o">:</span><span class="w"> </span><span class="mf">4</span>
<span class="linenos">13</span><span class="p">}</span>
</pre></div>
</div>
</div>
<p><a class="reference download internal" download="" href="../../_downloads/dca649c6abf7935b694a9b820bb4efc5/c_cpp_properties.json"><code class="xref download docutils literal notranslate"><span class="pre">Download</span></code></a></p>
</li>
</ol>
</section>
<section id="configure-the-build">
<h3>Configure the Build<a class="headerlink" href="#configure-the-build" title="Link to this heading"></a></h3>
<p>Execute <code class="docutils literal notranslate"><span class="pre">Ctrl+Shift+P</span></code>: <code class="docutils literal notranslate"><span class="pre">CMake:</span> <span class="pre">Configure</span></code></p>
<p>CMake should now be able to configure the project.
If not, cmake should give you at least a hint, what’s missing (normally external libraries).
Read <a class="reference internal" href="../../installation_guide/further_guidance/10_cmake.html#cmake"><span class="std std-ref">CMake Variables and Options</span></a> or <a class="reference internal" href="../../installation_guide/20_install_prerequisites.html#prerequisites"><span class="std std-ref">Installing Prerequisites</span></a> for more information.</p>
<div class="admonition-cmake admonition">
<p class="admonition-title">CMake</p>
<p>Some changes such as changing the build type (Debug/Release) will cause CMake to updates the configuration automatically.
Other changes won’t trigger an update, such as changing the paths to libraries (<cite>CMAKE_PREFIX_PATH</cite>), the cmake cache needs to be cleared before reconfiguration:
<code class="docutils literal notranslate"><span class="pre">Ctrl+Shift+P</span></code> &gt; <code class="docutils literal notranslate"><span class="pre">CMake:</span> <span class="pre">Delete</span> <span class="pre">Cache</span> <span class="pre">and</span> <span class="pre">Reconfigure</span></code></p>
</div>
</section>
<section id="debug-targets">
<h3>Debug Targets<a class="headerlink" href="#debug-targets" title="Link to this heading"></a></h3>
<p>CMake Tools and C++ Testmate automatically use custom launch configurations, if available.
When using the debugging functionality, the according executable will be executed from where they are built (per default inside the <code class="docutils literal notranslate"><span class="pre">build</span></code> folder).</p>
<ul>
<li><p>This is acceptable for unit test, which do not require openPASS specific libraries.
The corresponding config is <code class="docutils literal notranslate"><span class="pre">CMake</span> <span class="pre">Target</span></code>.</p></li>
<li><p>For the core, located at <code class="docutils literal notranslate"><span class="pre">./build/sim/src/core/opSimulation/opSimulation</span></code>, this does not work, as no libraries and no configurations are available.
As a solution, a second debug target <code class="docutils literal notranslate"><span class="pre">opsimulation</span></code> points at the installed executable instead.</p>
<div class="admonition warning">
<p class="admonition-title">Warning</p>
<p>Don’t forget to run the target <code class="docutils literal notranslate"><span class="pre">install</span></code> before debugging .</p>
</div>
</li>
</ul>
<ol class="arabic simple">
<li><p>Got to “Run and Debug” (<code class="docutils literal notranslate"><span class="pre">Ctrl+Shift+D</span></code>) and <em>create a launch.json file</em>.</p></li>
<li><p>Insert/Update:</p></li>
</ol>
<div class="sphinx-tabs docutils container">
<div aria-label="Tabbed content" class="closeable" role="tablist"><button aria-controls="panel-4-4-0" aria-selected="true" class="sphinx-tabs-tab" id="tab-4-4-0" name="4-0" role="tab" tabindex="0">Windows</button><button aria-controls="panel-4-4-1" aria-selected="false" class="sphinx-tabs-tab" id="tab-4-4-1" name="4-1" role="tab" tabindex="-1">Linux</button></div><div aria-labelledby="tab-4-4-0" class="sphinx-tabs-panel" id="panel-4-4-0" name="4-0" role="tabpanel" tabindex="0"><div class="literal-block-wrapper docutils container" id="id8">
<div class="code-block-caption"><span class="caption-text">launch.json</span><a class="headerlink" href="#id8" title="Link to this code"></a></div>
<div class="highlight-javascript notranslate"><div class="highlight"><pre><span></span><span class="linenos"> 1</span><span class="p">{</span>
<span class="linenos"> 2</span><span class="w">    </span><span class="s2">&quot;version&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;0.2.0&quot;</span><span class="p">,</span>
<span class="linenos"> 3</span><span class="w">    </span><span class="s2">&quot;configurations&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos"> 4</span><span class="w">        </span><span class="p">{</span>
<span class="linenos"> 5</span><span class="w">            </span><span class="c1">// FOR TESTMATE (SELECTED TEST) AND CMAKE (DEBUG CMAKE TARGET)</span>
<span class="linenos"> 6</span><span class="w">            </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;CMake Target&quot;</span><span class="p">,</span>
<span class="linenos"> 7</span><span class="w">            </span><span class="s2">&quot;type&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;cppdbg&quot;</span><span class="p">,</span>
<span class="linenos"> 8</span><span class="w">            </span><span class="s2">&quot;request&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;launch&quot;</span><span class="p">,</span>
<span class="linenos"> 9</span><span class="w">            </span><span class="s2">&quot;program&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${command:cmake.launchTargetPath}&quot;</span><span class="p">,</span>
<span class="linenos">10</span><span class="w">            </span><span class="s2">&quot;args&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[],</span>
<span class="linenos">11</span><span class="w">            </span><span class="s2">&quot;stopAtEntry&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">12</span><span class="w">            </span><span class="s2">&quot;cwd&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${workspaceFolder}&quot;</span><span class="p">,</span>
<span class="linenos">13</span><span class="w">            </span><span class="s2">&quot;environment&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">14</span><span class="w">                </span><span class="p">{</span>
<span class="linenos">15</span><span class="w">                    </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;PATH&quot;</span><span class="p">,</span>
<span class="linenos">16</span><span class="w">                    </span><span class="s2">&quot;value&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;$PATH:${command:msys2.root}\\bin;${command:mingw64.root}\\x86_64-w64-mingw32\\lib${command:cmake.buildkit.launch.path}&quot;</span>
<span class="linenos">17</span><span class="w">                </span><span class="p">}</span>
<span class="linenos">18</span><span class="w">            </span><span class="p">],</span>
<span class="linenos">19</span><span class="w">            </span><span class="s2">&quot;externalConsole&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">20</span><span class="w">            </span><span class="s2">&quot;MIMode&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;gdb&quot;</span><span class="p">,</span>
<span class="linenos">21</span><span class="w">            </span><span class="s2">&quot;miDebuggerPath&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${command:cmake.buildkit.gdb.exe}&quot;</span><span class="p">,</span>
<span class="linenos">22</span><span class="w">            </span><span class="s2">&quot;setupCommands&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">23</span><span class="w">                </span><span class="p">{</span>
<span class="linenos">24</span><span class="w">                    </span><span class="s2">&quot;description&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;Enable pretty-printing for gdb&quot;</span><span class="p">,</span>
<span class="linenos">25</span><span class="w">                    </span><span class="s2">&quot;text&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;-enable-pretty-printing&quot;</span><span class="p">,</span>
<span class="linenos">26</span><span class="w">                    </span><span class="s2">&quot;ignoreFailures&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">27</span><span class="w">                </span><span class="p">}</span>
<span class="linenos">28</span><span class="w">            </span><span class="p">]</span>
<span class="linenos">29</span><span class="w">        </span><span class="p">},</span>
<span class="linenos">30</span><span class="w">        </span><span class="p">{</span>
<span class="linenos">31</span><span class="w">            </span><span class="c1">// FOR DEBUGGING opSimulation (DON&#39;T FORGET TO CALL make install)</span>
<span class="linenos">32</span><span class="w">            </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;opsimulation&quot;</span><span class="p">,</span>
<span class="linenos">33</span><span class="w">            </span><span class="s2">&quot;type&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;cppdbg&quot;</span><span class="p">,</span>
<span class="linenos">34</span><span class="w">            </span><span class="s2">&quot;request&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;launch&quot;</span><span class="p">,</span>
<span class="linenos">35</span><span class="w">            </span><span class="s2">&quot;program&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${workspaceFolder}\\bin\\core\\opSimulation.exe&quot;</span><span class="p">,</span>
<span class="linenos">36</span><span class="w">            </span><span class="s2">&quot;args&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[],</span>
<span class="linenos">37</span><span class="w">            </span><span class="s2">&quot;stopAtEntry&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">38</span><span class="w">            </span><span class="s2">&quot;cwd&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${workspaceFolder}\\bin\\core&quot;</span><span class="p">,</span>
<span class="linenos">39</span><span class="w">            </span><span class="s2">&quot;environment&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">40</span><span class="w">                </span><span class="p">{</span>
<span class="linenos">41</span><span class="w">                    </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;PATH&quot;</span><span class="p">,</span>
<span class="linenos">42</span><span class="w">                    </span><span class="s2">&quot;value&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;$PATH:${command:msys2.root}\\bin;${command:mingw64.root}\\x86_64-w64-mingw32\\lib${command:cmake.buildkit.launch.path}&quot;</span>
<span class="linenos">43</span><span class="w">                </span><span class="p">}</span>
<span class="linenos">44</span><span class="w">            </span><span class="p">],</span>
<span class="linenos">45</span><span class="w">            </span><span class="s2">&quot;externalConsole&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">46</span><span class="w">            </span><span class="s2">&quot;MIMode&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;gdb&quot;</span><span class="p">,</span>
<span class="linenos">47</span><span class="w">            </span><span class="s2">&quot;miDebuggerPath&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${command:cmake.buildkit.gdb.exe}&quot;</span><span class="p">,</span>
<span class="linenos">48</span><span class="w">            </span><span class="s2">&quot;setupCommands&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">49</span><span class="w">                </span><span class="p">{</span>
<span class="linenos">50</span><span class="w">                    </span><span class="s2">&quot;description&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;Enable pretty-printing for gdb&quot;</span><span class="p">,</span>
<span class="linenos">51</span><span class="w">                    </span><span class="s2">&quot;text&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;-enable-pretty-printing&quot;</span><span class="p">,</span>
<span class="linenos">52</span><span class="w">                    </span><span class="s2">&quot;ignoreFailures&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">53</span><span class="w">                </span><span class="p">}</span>
<span class="linenos">54</span><span class="w">            </span><span class="p">]</span>
<span class="linenos">55</span><span class="w">        </span><span class="p">}</span>
<span class="linenos">56</span><span class="w">    </span><span class="p">]</span>
<span class="linenos">57</span><span class="p">}</span>
</pre></div>
</div>
</div>
<p><a class="reference download internal" download="" href="../../_downloads/29dd021e0bdb423fc1a0b9b1d8df02f7/launch.json"><code class="xref download docutils literal notranslate"><span class="pre">Download</span></code></a></p>
</div><div aria-labelledby="tab-4-4-1" class="sphinx-tabs-panel" hidden="true" id="panel-4-4-1" name="4-1" role="tabpanel" tabindex="0"><div class="literal-block-wrapper docutils container" id="id9">
<div class="code-block-caption"><span class="caption-text">launch.json</span><a class="headerlink" href="#id9" title="Link to this code"></a></div>
<div class="highlight-javascript notranslate"><div class="highlight"><pre><span></span><span class="linenos"> 1</span><span class="p">{</span>
<span class="linenos"> 2</span><span class="w">    </span><span class="s2">&quot;version&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;0.2.0&quot;</span><span class="p">,</span>
<span class="linenos"> 3</span><span class="w">    </span><span class="s2">&quot;configurations&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos"> 4</span><span class="w">        </span><span class="p">{</span>
<span class="linenos"> 5</span><span class="w">            </span><span class="c1">// FOR TESTMATE (SELECTED TEST) AND CMAKE (DEBUG CMAKE TARGET)</span>
<span class="linenos"> 6</span><span class="w">            </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;CMake Target&quot;</span><span class="p">,</span>
<span class="linenos"> 7</span><span class="w">            </span><span class="s2">&quot;type&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;cppdbg&quot;</span><span class="p">,</span>
<span class="linenos"> 8</span><span class="w">            </span><span class="s2">&quot;request&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;launch&quot;</span><span class="p">,</span>
<span class="linenos"> 9</span><span class="w">            </span><span class="s2">&quot;program&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${command:cmake.launchTargetPath}&quot;</span><span class="p">,</span>
<span class="linenos">10</span><span class="w">            </span><span class="s2">&quot;args&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[],</span>
<span class="linenos">11</span><span class="w">            </span><span class="s2">&quot;stopAtEntry&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">12</span><span class="w">            </span><span class="s2">&quot;cwd&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;${workspaceFolder}&quot;</span><span class="p">,</span>
<span class="linenos">13</span><span class="w">            </span><span class="s2">&quot;externalConsole&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">14</span><span class="w">            </span><span class="s2">&quot;MIMode&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;gdb&quot;</span><span class="p">,</span>
<span class="linenos">15</span><span class="w">            </span><span class="s2">&quot;setupCommands&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">16</span><span class="w">                </span><span class="p">{</span>
<span class="linenos">17</span><span class="w">                    </span><span class="s2">&quot;description&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;Enable pretty-printing for gdb&quot;</span><span class="p">,</span>
<span class="linenos">18</span><span class="w">                    </span><span class="s2">&quot;text&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;-enable-pretty-printing&quot;</span><span class="p">,</span>
<span class="linenos">19</span><span class="w">                    </span><span class="s2">&quot;ignoreFailures&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">20</span><span class="w">                </span><span class="p">}</span>
<span class="linenos">21</span><span class="w">            </span><span class="p">]</span>
<span class="linenos">22</span><span class="w">        </span><span class="p">},</span>
<span class="linenos">23</span><span class="w">        </span><span class="p">{</span>
<span class="linenos">24</span><span class="w">            </span><span class="c1">// FOR DEBUGGING opSimulation (DON&#39;T FORGET TO CALL make install)</span>
<span class="linenos">25</span><span class="w">            </span><span class="s2">&quot;name&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;opsimulation&quot;</span><span class="p">,</span>
<span class="linenos">26</span><span class="w">            </span><span class="s2">&quot;type&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;cppdbg&quot;</span><span class="p">,</span>
<span class="linenos">27</span><span class="w">            </span><span class="s2">&quot;request&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;launch&quot;</span><span class="p">,</span>
<span class="linenos">28</span><span class="w">            </span><span class="s2">&quot;program&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;/usr/local/openPASS/bin/core/opSimulation&quot;</span><span class="p">,</span>
<span class="linenos">29</span><span class="w">            </span><span class="s2">&quot;args&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[],</span>
<span class="linenos">30</span><span class="w">            </span><span class="s2">&quot;stopAtEntry&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">31</span><span class="w">            </span><span class="s2">&quot;cwd&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;/usr/local/openPASS/bin/core/&quot;</span><span class="p">,</span>
<span class="linenos">32</span><span class="w">            </span><span class="s2">&quot;externalConsole&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">false</span><span class="p">,</span>
<span class="linenos">33</span><span class="w">            </span><span class="s2">&quot;MIMode&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;gdb&quot;</span><span class="p">,</span>
<span class="linenos">34</span><span class="w">            </span><span class="s2">&quot;setupCommands&quot;</span><span class="o">:</span><span class="w"> </span><span class="p">[</span>
<span class="linenos">35</span><span class="w">                </span><span class="p">{</span>
<span class="linenos">36</span><span class="w">                    </span><span class="s2">&quot;description&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;Enable pretty-printing for gdb&quot;</span><span class="p">,</span>
<span class="linenos">37</span><span class="w">                    </span><span class="s2">&quot;text&quot;</span><span class="o">:</span><span class="w"> </span><span class="s2">&quot;-enable-pretty-printing&quot;</span><span class="p">,</span>
<span class="linenos">38</span><span class="w">                    </span><span class="s2">&quot;ignoreFailures&quot;</span><span class="o">:</span><span class="w"> </span><span class="kc">true</span>
<span class="linenos">39</span><span class="w">                </span><span class="p">}</span>
<span class="linenos">40</span><span class="w">            </span><span class="p">]</span>
<span class="linenos">41</span><span class="w">        </span><span class="p">}</span>
<span class="linenos">42</span><span class="w">    </span><span class="p">]</span>
<span class="linenos">43</span><span class="p">}</span>
</pre></div>
</div>
</div>
<p><a class="reference download internal" download="" href="../../_downloads/f717c80213b149820a0dc8e07e803940/launch.json"><code class="xref download docutils literal notranslate"><span class="pre">Download</span></code></a></p>
</div></div>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>IntelliSense uses the <code class="docutils literal notranslate"><span class="pre">compile_commands.json</span></code> of generated through <code class="docutils literal notranslate"><span class="pre">CMAKE_EXPORT_COMPILE_COMMANDS=ON</span></code> (see <code class="docutils literal notranslate"><span class="pre">settings.json</span></code>).
This is necessary for proper resolution of the include files.</p>
</div>
</section>
</section>
<section id="troubleshooting">
<h2>Troubleshooting<a class="headerlink" href="#troubleshooting" title="Link to this heading"></a></h2>
<p><img alt="win_only" src="../../_images/win_only.png" /> <strong>Program does not start</strong></p>
<p>The most effective way to debug startup issues is by means of the <a class="reference external" href="https://docs.microsoft.com/en-us/sysinternals/downloads/procmon">Process Monitor</a>.</p>
<p>But normally, its a missing DLL. When executing the program via command line or explorer a message box should prompt which DLLs are missing.
A simple solution is to copy the according DLLs into the folder of the executable.
Another solution is to make the path available by extending the <code class="docutils literal notranslate"><span class="pre">PATH</span></code> environment variable.
Potential sources for missing DLLs are <code class="docutils literal notranslate"><span class="pre">C:\msys64\mingw64\bin</span></code>, <code class="docutils literal notranslate"><span class="pre">C:\msys64\mingw64\x86_64-w64-mingw32\lib</span></code>, and the <code class="docutils literal notranslate"><span class="pre">build</span></code> folder itself.</p>
<p><strong>Tests are not listed</strong></p>
<p>For test discovery, C++ Testmate needs to know the location of all additional dependencies.
This information is retrieved from the current debug configuration.</p>
<ol class="arabic simple">
<li><p>Testmate discovers tests only after they are built.
It pays to <code class="docutils literal notranslate"><span class="pre">Run</span> <span class="pre">CTest</span></code> to build all test targets.
After this, you should see all tests in the testing pane on the left.</p></li>
<li><p>Still not listed? Set <code class="docutils literal notranslate"><span class="pre">testMate.cpp.log.logfile</span></code> in <code class="docutils literal notranslate"><span class="pre">settings.json</span></code> and check log.</p>
<ol class="arabic simple">
<li><p>Test executable not mentioned at all:
Executable name might not fit (check glob pattern in <code class="docutils literal notranslate"><span class="pre">testMate.cpp.test.executables</span></code>).</p></li>
<li><p>Log reports <em>Error: Not a supported test executable</em>: a library/DLL might be missing.</p></li>
</ol>
</li>
</ol>
</section>
</section>


           </div>
          </div>
          <footer><div class="rst-footer-buttons" role="navigation" aria-label="Footer">
        <a href="../10_ide_support.html" class="btn btn-neutral float-left" title="IDE Support" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left" aria-hidden="true"></span> Previous</a>
        <a href="../20_documentation.html" class="btn btn-neutral float-right" title="Documentation Concept" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right" aria-hidden="true"></span></a>
    </div>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2025 openPASS Working Group.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>